/// Twordlist
/// Twordlist extends the functionality of Tlist with functions
/// specifically for examing words.

typedef struct Tword_struct {
   int pronoun;                  // Is it a pronoun?                  1 = true; 0 = false
   int candidate;                // Is it a proper noun candidate?    1 = true; 0 = false
   int sentence;                 // Sentence id number.
   int word;
   int gender;
   int number;
   int type;
   char * string;
   // Word tests for pronouns:
   Tlist *proximity_w;           // A proximity score for each candidate word.  (how many words away)
   Tlist *proximity_s;           // A proximity score for each candidate word.  (how many sentences away)
   Tlist *gender_list;                // A lookup score for each candidate word.  (Does the word agree?)
   Tlist *number_list;                // A lookup score for each candidate word.  (Does the word agree?)
} Tword;

// A hueristic is used to accumulate all of this information and give a "best guess".  
// Each word is linked to a more detailed summary of it's scoreing with it's ranking against
// the other candidate words.

Tlist * Tword_list_new ();
void Tword_list_delete (Tlist * list);
void Tword_list_push_back (Tlist * list, char *s, int sentence, int word, int pronoun, int candidate);
void Tword_list_sublist_push_back (Tlist * list, int data);
void Tword_list_read_file (Tlist * list, char *filename);
void Tword_list_print_lispish (Tlist * list);
void Tword_list_print_plain (Tlist * list);
void Tword_list_print_html (Tlist * list);
